// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'SME2OLE.pas' rev: 5.00

#ifndef SME2OLEHPP
#define SME2OLEHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <SMEEngine.hpp>	// Pascal unit
#include <SME2Cell.hpp>	// Pascal unit
#include <ExportDS.hpp>	// Pascal unit
#include <Db.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Sme2ole
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TMSExcelVersion { evExcelAuto, evExcel2, evExcel2FarEast, evExcel3, evExcel4, evExcel5, evExcel7, 
	evExcel9597 };
#pragma option pop

#pragma option push -b-
enum TSMEMeasure { emPoint, emInch, emCentimeters, emPicas };
#pragma option pop

#pragma option push -b-
enum TSMEOrientation { emDefault, emPortrait, emLandscape };
#pragma option pop

class DELPHICLASS TSMEPageSetup;
class PASCALIMPLEMENTATION TSMEPageSetup : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TSMEMeasure FMeasure;
	bool FUseDefault;
	float FTopMargin;
	float FBottomMargin;
	float FLeftMargin;
	float FRightMargin;
	float FTableWidth;
	TSMEOrientation FOrientation;
	
public:
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property TSMEMeasure Measure = {read=FMeasure, write=FMeasure, default=0};
	__property bool UseDefault = {read=FUseDefault, write=FUseDefault, default=1};
	__property float TopMargin = {read=FTopMargin, write=FTopMargin};
	__property float BottomMargin = {read=FBottomMargin, write=FBottomMargin};
	__property float LeftMargin = {read=FLeftMargin, write=FLeftMargin};
	__property float RightMargin = {read=FRightMargin, write=FRightMargin};
	__property float TableWidth = {read=FTableWidth, write=FTableWidth};
	__property TSMEOrientation Orientation = {read=FOrientation, write=FOrientation, default=0};
public:
		
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TSMEPageSetup(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSMEPageSetup(void) : Classes::TPersistent() { }
	#pragma option pop
	
};


class DELPHICLASS TSMExportToExcel;
class PASCALIMPLEMENTATION TSMExportToExcel : public Exportds::TSMExportBaseComponent 
{
	typedef Exportds::TSMExportBaseComponent inherited;
	
private:
	TMSExcelVersion FExcelVersion;
	AnsiString FTemplateFile;
	bool IsNewestCom;
	bool FAutoFitColumns;
	bool FUseCurrentInstance;
	TSMEPageSetup* FPageSetup;
	bool __fastcall IsVersionStore(void);
	void __fastcall SetPageSetup(TSMEPageSetup* Value);
	
protected:
	virtual void __fastcall Prepare(void);
	virtual AnsiString __fastcall GetFormat(Db::TFieldType ft);
	
public:
	Variant xls;
	Variant xlw;
	__fastcall virtual TSMExportToExcel(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMExportToExcel(void);
	virtual AnsiString __fastcall Extension();
	
__published:
	__property bool AutoFitColumns = {read=FAutoFitColumns, write=FAutoFitColumns, default=0};
	__property bool UseCurrentInstance = {read=FUseCurrentInstance, write=FUseCurrentInstance, default=0
		};
	__property TMSExcelVersion ExcelVersion = {read=FExcelVersion, write=FExcelVersion, stored=IsVersionStore
		, default=0};
	__property AnsiString TemplateFile = {read=FTemplateFile, write=FTemplateFile};
	__property TSMEPageSetup* PageSetup = {read=FPageSetup, write=SetPageSetup};
	__property ActionAfterExport ;
	__property FileName ;
	__property AddTitle ;
	__property CharacterSet ;
	__property ExportStyle ;
	__property Header ;
	__property Footer ;
	__property OnGetCellParams ;
};


class DELPHICLASS TSMExportToWord;
class PASCALIMPLEMENTATION TSMExportToWord : public Sme2cell::TSMExportToCellFile 
{
	typedef Sme2cell::TSMExportToCellFile inherited;
	
private:
	bool IsNewestCom;
	bool FUseCurrentInstance;
	TSMEPageSetup* FPageSetup;
	AnsiString FTemplateFile;
	AnsiString strLastFileName;
	Variant arrColWidths;
	int intTblRowCount;
	int intTblColCount;
	bool FAutoFitColumns;
	int __fastcall GetColorIndex(Graphics::TColor color);
	float __fastcall GetMeasureMargin(TSMEMeasure Measure, float Value);
	void __fastcall SetPageSetup(TSMEPageSetup* Value);
	
protected:
	virtual void __fastcall InternalFileCreate(const AnsiString AFileName);
	
public:
	Variant word;
	Variant document;
	Variant table;
	__fastcall virtual TSMExportToWord(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMExportToWord(void);
	virtual AnsiString __fastcall Extension();
	virtual void __fastcall CloseFileStream(void);
	virtual void __fastcall WriteDataBegin(void);
	virtual void __fastcall WriteDimensions(int intRowCount, int intColCount);
	virtual void __fastcall WriteColWidth(int intCurColumn, int intColWidth);
	virtual void __fastcall WriteData(Db::TField* fld, Smeengine::TCellType CellType, int ARow, int ACol
		, AnsiString AString, Classes::TAlignment al, Graphics::TFont* font, Graphics::TColor color);
	virtual void __fastcall WriteRowStart(bool IsAddedTitle);
	
__published:
	__property TSMEPageSetup* PageSetup = {read=FPageSetup, write=SetPageSetup};
	__property bool UseCurrentInstance = {read=FUseCurrentInstance, write=FUseCurrentInstance, default=0
		};
	__property AnsiString TemplateFile = {read=FTemplateFile, write=FTemplateFile};
	__property bool AutoFitColumns = {read=FAutoFitColumns, write=FAutoFitColumns, default=0};
	__property ActionAfterExport ;
	__property FileName ;
	__property AddTitle ;
	__property CharacterSet ;
	__property ExportStyle ;
	__property Header ;
	__property Footer ;
	__property OnGetCellParams ;
};


#pragma option push -b-
enum TMSAccessVersion { avAuto, avAccess97, avAccess2000 };
#pragma option pop

class DELPHICLASS TSMExportToAccess;
class PASCALIMPLEMENTATION TSMExportToAccess : public Exportds::TSMExportBaseComponent 
{
	typedef Exportds::TSMExportBaseComponent inherited;
	
private:
	bool IsNewestCom;
	TMSAccessVersion FMSAccessVersion;
	bool FUseCurrentInstance;
	AnsiString FUserName;
	AnsiString FPassword;
	bool __fastcall IsVersionStore(void);
	
protected:
	virtual void __fastcall Prepare(void);
	virtual AnsiString __fastcall GetFieldStr(Db::TField* Field);
	
public:
	OleVariant access;
	OleVariant db;
	OleVariant recordset;
	__fastcall virtual TSMExportToAccess(Classes::TComponent* AOwner);
	virtual AnsiString __fastcall Extension();
	
__published:
	__property bool UseCurrentInstance = {read=FUseCurrentInstance, write=FUseCurrentInstance, default=0
		};
	__property TMSAccessVersion MSAccessVersion = {read=FMSAccessVersion, write=FMSAccessVersion, stored=
		IsVersionStore, default=0};
	__property AnsiString UserName = {read=FUserName, write=FUserName};
	__property AnsiString Password = {read=FPassword, write=FPassword};
	__property ActionAfterExport ;
	__property FileName ;
	__property TableName ;
	__property CharacterSet ;
	__property OnGetCellParams ;
public:
	#pragma option push -w-inl
	/* TSMExportBaseComponent.Destroy */ inline __fastcall virtual ~TSMExportToAccess(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE TMSExcelVersion DefaultExcelVersion;
extern PACKAGE TMSAccessVersion DefaultAccessVersion;
extern PACKAGE bool DefaultExportAsRealHeaderFooter;
extern PACKAGE bool __fastcall MSExcelIsInstalled(void);
extern PACKAGE bool __fastcall MSWordIsInstalled(void);
extern PACKAGE bool __fastcall MSAccessIsInstalled(void);
extern PACKAGE void __fastcall GetTableNames(Classes::TStrings* lst, const AnsiString DBName);

}	/* namespace Sme2ole */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Sme2ole;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// SME2OLE
