unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, SMEEngine, SMEEngSG, ExportDS, SME2Cell, SME2TXT;

type
  TfrmMain = class(TForm)
    StringGrid1: TStringGrid;
    btnExport: TButton;
    btnAbout: TButton;
    btnClose: TButton;
    SMExportToText1: TSMExportToText;
    SMEStringGridDataEngine1: TSMEStringGridDataEngine;
    procedure btnCloseClick(Sender: TObject);
    procedure btnAboutClick(Sender: TObject);
    procedure btnExportClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

procedure TfrmMain.btnCloseClick(Sender: TObject);
begin
  Close
end;

procedure TfrmMain.btnAboutClick(Sender: TObject);
begin
  SMExportToText1.AboutSME
end;

procedure TfrmMain.btnExportClick(Sender: TObject);
begin
  {export from string grid}
  SMExportToText1.ColumnSource := csDataEngine;

  {this is a CSV}
  SMExportToText1.Fixed := False;

  SMExportToText1.FileName := ExtractFilePath(Application.ExeName) + 'smexport.csv';

  {add header and footer}
  SMExportToText1.Header.Clear;
  SMExportToText1.Header.Add(Caption);
  SMExportToText1.Header.Add('');

  SMExportToText1.Footer.Clear;
  SMExportToText1.Footer.Add('');
  SMExportToText1.Footer.Add('Generated by SMExport suite: http://www.scalabium.com');

  {start}
  SMExportToText1.Execute;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
var
  i, j: Integer;
begin
  {fill random values for StringGrid}
  with StringGrid1 do
  begin
    ColCount := Random(100)+5;
    RowCount := Random(1000)+7;
    FixedCols := 1;
    FixedRows := 1;
    for j := 0 to ColCount-1 do
    begin
      ColWidths[j] := Random(150);
      for i := 0 to RowCount-1 do
        Cells[j, i] := 'Random' + IntToStr(Random(10000));
    end;
  end;
end;

end.
